﻿-- Mythbusters
-- Add in Summary Page
-- Add By Class Section
-- Add Overhealing and average Overhealing
-- Maybe add Health to estimate rank for other players


MythBusters = {}
local main = UI.CreateContext("MythBusterUI")
local MBUI = UI.CreateFrame("Frame","Background",main)
local MBscroll = UI.CreateFrame("RiftScrollbar","Scroller",main)
local MBclose = UI.CreateFrame("RiftButton","Close Button",main)

local MBAbilitytext = UI.CreateFrame("Text","Ability Names",main)
local MBCounttext = UI.CreateFrame("Text","Count Text",main)
local MBDmgtext = UI.CreateFrame("Text","Damage Text",main)
local MBAvgtext = UI.CreateFrame("Text","Average Text",main)

local MBTaken = UI.CreateFrame("Frame","Damage Taken",main)
local MBDealt = UI.CreateFrame("Frame","Damage Dealt",main)
local MBKD = UI.CreateFrame("Frame","Kills and Deaths",main)
local MBHealTaken = UI.CreateFrame("Frame","Heals Taken",main)
local MBHealDealt = UI.CreateFrame("Frame","Heals Received",main)
local MBBigHits = UI.CreateFrame("Frame","Biggest Hits",main)

local MBTakentext = UI.CreateFrame("Text","Dmg Taken",main)
local MBDealttext = UI.CreateFrame("Text","Dmg Dealt",main)
local MBKDtext = UI.CreateFrame("Text","K/D",main)
local MBHealTakentext = UI.CreateFrame("Text","Heals Taken",main)
local MBHealDealttext = UI.CreateFrame("Text","Heals Given",main)
local MBBigHitstext = UI.CreateFrame("Text","Ouch",main)



local initialInfo = {
				charID = nil,
				warrkills = 0,
				roguekills = 0,
				magekills = 0,
				clerickills = 0,
				warrdeaths = 0,
				roguedeaths = 0,
				magedeaths = 0,
				clericdeaths = 0
}
local MBTakenclick = true
local MBDealtclick = false
local MBKDclick = false
-- local MBIncoming = {}
-- local MBOutgoing = {}


function MythBusters.Main()
	if not MythBustersInfo then
		MythBustersInfo = initialInfo
	end
	if not MBIncoming then
		MBIncoming = {}
	end
	if not MBOutgoing then
		MBOutgoing = {}
	end
	if not MBHealIncoming then
		MBHealIncoming = {}
	end
	if not MBHealOutgoing then
		MBHealOutgoing = {}
	end
	if not MythBustersInfo.charID then
		MythBusterID = Inspect.Unit.Detail("player")
		MythBustersInfo.charID = MythBusterID.id
	end
end

function MythBusters.Build(a)
	if a ~= "MythBusters" then
		return
	end
	MBUI:SetWidth(620)
	MBUI:SetHeight(700)
	MBUI:SetLayer(1)
	MBUI:SetVisible(false)
	MBUI:SetBackgroundColor(0,0,0,1)
	MBUI:SetPoint("TOPLEFT",main,"TOPLEFT",500,100)
	
	MBscroll:SetVisible(false)
	MBscroll:SetLayer(1)
	MBscroll:SetEnabled(false)
	MBscroll:SetHeight(MBUI:GetHeight())
	MBscroll:SetOrientation("vertical")
	MBscroll:SetPoint("TOPLEFT",main,"TOPLEFT",MBUI:GetRight(),MBUI:GetTop())
	function MBscroll.Event:ScrollbarChange()
		MythBusters.DisplayStats()
	end
	function MBscroll.Event:ScrollbarRelease()
		MythBusters.DisplayStats()
	end
	
	MBclose:SetVisible(false)
	MBclose:SetLayer(2)
	MBclose:SetPoint("TOPLEFT",main,"TOPLEFT",MBUI:GetLeft(),MBUI:GetTop()-MBclose:GetHeight())
	MBclose:SetMouseMasking("limited")
	MBclose:SetSkin("close")
	function MBclose.Event:LeftClick()
		MBUI:SetVisible(false)
		MBscroll:SetVisible(false)
		MBclose:SetVisible(false)
		MBAbilitytext:SetVisible(false)
		MBCounttext:SetVisible(false)
		MBDmgtext:SetVisible(false)
		MBAvgtext:SetVisible(false)
		MBTaken:SetVisible(false)
		MBTakentext:SetVisible(false)
		MBDealt:SetVisible(false)
		MBDealttext:SetVisible(false)
		MBKD:SetVisible(false)
		MBKDtext:SetVisible(false)
		MBHealTaken:SetVisible(false)
		MBHealTakentext:SetVisible(false)
		MBHealDealt:SetVisible(false)
		MBHealDealttext:SetVisible(false)
		MBBigHits:SetVisible(false)
		MBBigHitstext:SetVisible(false)
	end
	
	MBAbilitytext:SetLayer(2)
	MBAbilitytext:SetVisible(false)
	MBAbilitytext:SetPoint("TOPLEFT",MBUI,"TOPLEFT",0,0)
	
	MBCounttext:SetPoint("TOPLEFT",MBUI,"TOPLEFT",MBUI:GetWidth()/4,0)
	MBCounttext:SetVisible(false)
	MBCounttext:SetLayer(2)
	
	MBDmgtext:SetPoint("TOPLEFT",MBUI,"TOPLEFT",MBUI:GetWidth()/2,0)
	MBDmgtext:SetVisible(false)
	MBDmgtext:SetLayer(2)
	
	MBAvgtext:SetPoint("TOPLEFT",MBUI,"TOPLEFT",(3*MBUI:GetWidth())/4,0)
	MBAvgtext:SetVisible(false)
	MBAvgtext:SetLayer(2)
	
	MBTaken:SetWidth(100)
	MBTaken:SetHeight(50)
	MBTaken:SetLayer(1)
	MBTaken:SetVisible(false)
	MBTaken:SetMouseMasking("limited")
	MBTaken:SetBackgroundColor(0.7,0,0,1)
	MBTaken:SetPoint("TOPLEFT",main,"TOPLEFT",MBUI:GetLeft()+MBclose:GetWidth(),MBUI:GetTop()-MBTaken:GetHeight())
	function MBTaken.Event:LeftClick()
		MBTakenclick = true
		MBDealtclick = false
		MBHealTakenclick = false
		MBHealDealtclick = false
		MBKDclick = false
		MBBigHitsclick = false
		MBTaken:SetBackgroundColor(0.7,0,0,1)
		MBDealt:SetBackgroundColor(0,0.7,0,1)
		MBHealTaken:SetBackgroundColor(0,0.7,0,1)
		MBHealDealt:SetBackgroundColor(0,0.7,0,1)
		MBKD:SetBackgroundColor(0,0.7,0,1)
		MBBigHits:SetBackgroundColor(0,0.7,0,1)
		MythBusters.DisplayStats()
	end
	MBTakentext:SetLayer(2)
	MBTakentext:SetVisible(false)
	MBTakentext:SetFontSize(18)
	MBTakentext:SetText(MBTakentext:GetName())
	MBTakentext:SetPoint("TOPLEFT",MBTaken,"TOPLEFT",0,0)
	
	MBDealt:SetWidth(100)
	MBDealt:SetHeight(50)
	MBDealt:SetLayer(1)
	MBDealt:SetVisible(false)
	MBDealt:SetMouseMasking("limited")
	MBDealt:SetBackgroundColor(0,0.7,0,1)
	MBDealt:SetPoint("TOPLEFT",main,"TOPLEFT",MBTaken:GetRight(),MBUI:GetTop()-MBTaken:GetHeight())
	function MBDealt.Event:LeftClick()
		MBTakenclick = false
		MBDealtclick = true
		MBHealTakenclick = false
		MBHealDealtclick = false
		MBKDclick = false
		MBBigHitsclick = false
		MBTaken:SetBackgroundColor(0,0.7,0,1)
		MBDealt:SetBackgroundColor(0.7,0,0,1)
		MBHealTaken:SetBackgroundColor(0,0.7,0,1)
		MBHealDealt:SetBackgroundColor(0,0.7,0,1)
		MBKD:SetBackgroundColor(0,0.7,0,1)
		MBBigHits:SetBackgroundColor(0,0.7,0,1)
		MythBusters.DisplayStats()
	end
	MBDealttext:SetLayer(2)
	MBDealttext:SetVisible(false)
	MBDealttext:SetFontSize(18)
	MBDealttext:SetText(MBDealttext:GetName())
	MBDealttext:SetPoint("TOPLEFT",MBDealt,"TOPLEFT",0,0)
	
	MBHealTaken:SetLayer(1)
	MBHealTaken:SetWidth(100)
	MBHealTaken:SetHeight(50)
	MBHealTaken:SetVisible(false)
	MBHealTaken:SetMouseMasking("limited")
	MBHealTaken:SetBackgroundColor(0,0.7,0,1)
	MBHealTaken:SetPoint("TOPLEFT",main,"TOPLEFT",MBDealt:GetRight(),MBUI:GetTop()-MBTaken:GetHeight())
	function MBHealTaken.Event:LeftClick()
		MBTakenclick = false
		MBDealtclick = false
		MBHealTakenclick = true
		MBHealDealtclick = false
		MBKDclick = false
		MBBigHitsclick = false
		MBTaken:SetBackgroundColor(0,0.7,0,1)
		MBDealt:SetBackgroundColor(0,0.7,0,1)
		MBHealTaken:SetBackgroundColor(0.7,0,0,1)
		MBHealDealt:SetBackgroundColor(0,0.7,0,1)
		MBKD:SetBackgroundColor(0,0.7,0,1)
		MBBigHits:SetBackgroundColor(0,0.7,0,1)
		MythBusters.DisplayStats()
	end
	MBHealTakentext:SetLayer(2)
	MBHealTakentext:SetVisible(false)
	MBHealTakentext:SetFontSize(18)
	MBHealTakentext:SetText(MBHealTakentext:GetName())
	MBHealTakentext:SetPoint("TOPLEFT",MBHealTaken,"TOPLEFT",0,0)
	
	MBHealDealt:SetLayer(1)
	MBHealDealt:SetWidth(100)
	MBHealDealt:SetHeight(50)
	MBHealDealt:SetVisible(false)
	MBHealDealt:SetMouseMasking("limited")
	MBHealDealt:SetBackgroundColor(0,0.7,0,1)
	MBHealDealt:SetPoint("TOPLEFT",main,"TOPLEFT",MBHealTaken:GetRight(),MBUI:GetTop()-MBTaken:GetHeight())
	function MBHealDealt.Event:LeftClick()
		MBTakenclick = false
		MBDealtclick = false
		MBHealTakenclick = false
		MBHealDealtclick = true
		MBKDclick = false
		MBBigHitsclick = false
		MBTaken:SetBackgroundColor(0,0.7,0,1)
		MBDealt:SetBackgroundColor(0,0.7,0,1)
		MBHealTaken:SetBackgroundColor(0,0.7,0,1)
		MBHealDealt:SetBackgroundColor(0.7,0,0,1)
		MBKD:SetBackgroundColor(0,0.7,0,1)
		MBBigHits:SetBackgroundColor(0,0.7,0,1)
		MythBusters.DisplayStats()
	end
	MBHealDealttext:SetLayer(2)
	MBHealDealttext:SetVisible(false)
	MBHealDealttext:SetFontSize(18)
	MBHealDealttext:SetText(MBHealDealttext:GetName())
	MBHealDealttext:SetPoint("TOPLEFT",MBHealDealt,"TOPLEFT",0,0)
	
	MBKD:SetWidth(100)
	MBKD:SetHeight(50)
	MBKD:SetLayer(1)
	MBKD:SetVisible(false)
	MBKD:SetMouseMasking("limited")
	MBKD:SetBackgroundColor(0,0.7,0,1)
	MBKD:SetPoint("TOPLEFT",main,"TOPLEFT",MBHealDealt:GetRight(),MBUI:GetTop()-MBTaken:GetHeight())
	function MBKD.Event:LeftClick()
		MBTakenclick = false
		MBDealtclick = false
		MBHealTakenclick = false
		MBHealDealtclick = false
		MBKDclick = true
		MBBigHitsclick = false
		MBTaken:SetBackgroundColor(0,0.7,0,1)
		MBDealt:SetBackgroundColor(0,0.7,0,1)
		MBHealTaken:SetBackgroundColor(0,0.7,0,1)
		MBHealDealt:SetBackgroundColor(0,0.7,0,1)
		MBKD:SetBackgroundColor(0.7,0,0,1)
		MBBigHits:SetBackgroundColor(0,0.7,0,1)
		MythBusters.DisplayStats()
	end
	MBKDtext:SetLayer(2)
	MBKDtext:SetVisible(false)
	MBKDtext:SetFontSize(18)
	MBKDtext:SetText(MBKDtext:GetName())
	MBKDtext:SetPoint("TOPLEFT",MBKD,"TOPLEFT",40,0)
	
	MBBigHits:SetWidth(100)
	MBBigHits:SetHeight(50)
	MBBigHits:SetLayer(1)
	MBBigHits:SetVisible(false)
	MBBigHits:SetMouseMasking("limited")
	MBBigHits:SetBackgroundColor(0,0.7,0,1)
	MBBigHits:SetPoint("TOPLEFT",main,"TOPLEFT",MBKD:GetRight(),MBUI:GetTop()-MBTaken:GetHeight())
	function MBBigHits.Event:LeftClick()
		MBTakenclick = false
		MBDealtclick = false
		MBHealTakenclick = false
		MBHealDealtclick = false
		MBKDclick = false
		MBBigHitsclick = true
		MBTaken:SetBackgroundColor(0,0.7,0,1)
		MBDealt:SetBackgroundColor(0,0.7,0,1)
		MBHealTaken:SetBackgroundColor(0,0.7,0,1)
		MBHealDealt:SetBackgroundColor(0,0.7,0,1)
		MBKD:SetBackgroundColor(0,0.7,0,1)
		MBBigHits:SetBackgroundColor(0.7,0,0,1)
		MythBusters.DisplayStats()
	end
	MBBigHitstext:SetLayer(2)
	MBBigHitstext:SetVisible(false)
	MBBigHitstext:SetFontSize(18)
	MBBigHitstext:SetText(MBBigHitstext:GetName())
	MBBigHitstext:SetPoint("TOPLEFT",MBBigHits,"TOPLEFT",30,0)
	print("MythBusters Loaded.")
end

function MythBusters.WhoIs(info)
	if info then
		if info.caster == MythBustersInfo.charID then
			MythBusterIsPlayer = Inspect.Unit.Detail(info.target)
			if MythBusterIsPlayer.player then
				MythBusters.ItWasMe(info)
				-- print("Outgoing")
				-- dump(MBOutgoing)
			end
		else
			MythBusterIsPlayer = Inspect.Unit.Detail(info.caster)
			if MythBusterIsPlayer then
				if MythBusterIsPlayer.player then
					if info.target == MythBustersInfo.charID then
						MythBusters.ItWasntMe(info)
						-- print("Incoming")
						-- dump(MBIncoming)
					end
				end
			end
		end
	end
end

function MythBusters.HealWhoIs(info)
	--dump(info)
	if info then
		if info.abilityName == "Revive" or info.abilityName == "Post Phase" or info.abilityName == "Pre Phase" then
			return
		end
		if info.caster == MythBustersInfo.charID then
			MythBusterIsPlayer = Inspect.Unit.Detail(info.target)
			if MythBusterIsPlayer.player then
				MythBusters.ItWasMeHealing(info)
				if info.target == MythBustersInfo.charID then
					MythBusters.ItWasntMeHealing(info)
				end
				-- print("Outgoing")
				-- dump(MBOutgoing)
			end
		else
			MythBusterIsPlayer = Inspect.Unit.Detail(info.caster)
			if MythBusterIsPlayer then
				if MythBusterIsPlayer.player then
					if info.target == MythBustersInfo.charID then
						MythBusters.ItWasntMeHealing(info)
						-- print("Incoming")
						-- dump(MBIncoming)
					end
				end
			end
		end
	end
end

function MythBusters.ItWasMe(info)
	if info then
		-- print("Outgoing")
		-- dump(info)
		if table.maxn(MBOutgoing) == 0 then
			table.insert(MBOutgoing,{name = info.abilityName,count = 1,dmg = info.damage})
			return
		end
		for i=1,table.maxn(MBOutgoing)+1,1 do
			if i == table.maxn(MBOutgoing)+1 then
				table.insert(MBOutgoing,{name = info.abilityName,count = 1,dmg = info.damage})
				return
			end
			if MBOutgoing[i].name == info.abilityName then
				MBOutgoing[i].count = MBOutgoing[i].count+1
				if not MBOutgoing[i].dmg then
					MBOutgoing[i].dmg = info.damage
				else
					if info.damage then
						MBOutgoing[i].dmg = MBOutgoing[i].dmg+info.damage
					else
						MBOutgoing[i].dmg = MBOutgoing[i].dmg
					end
				end
				break
			end
		end
	end
end

function MythBusters.ItWasntMe(info)
	if info then
		-- print("Incoming")
		-- dump(info)
		if table.maxn(MBIncoming) == 0 then
			local MBvalor = Inspect.Stat("valor")
			table.insert(MBIncoming,{name = info.abilityName,count = 1,dmg = info.damage,maxhit = info.damage,val = MBvalor})
			return
		end
		for i=1,table.maxn(MBIncoming)+1,1 do
			if i == table.maxn(MBIncoming)+1 then
				local MBvalor = Inspect.Stat("valor")
				table.insert(MBIncoming,{name = info.abilityName,count = 1,dmg = info.damage,maxhit = info.damage,val = MBvalor})
				return
			end
			if MBIncoming[i].name == info.abilityName then
				MBIncoming[i].count = MBIncoming[i].count+1
				if not MBIncoming[i].dmg then
					if info.damage then
						MBIncoming[i].dmg = info.damage
					else
						MBIncoming[i].dmg = 0
					end
				else
					if info.damage then
						MBIncoming[i].dmg = MBIncoming[i].dmg+info.damage
						if not MBIncoming[i].maxhit then
							local MBValor = Inspect.Stat("valor")
							MBIncoming[i].maxhit = info.damage
							MBIncoming[i].val = MBValor
						else
							if info.damage > MBIncoming[i].maxhit then
								local MBValor = Inspect.Stat("valor")
								MBIncoming[i].maxhit = info.damage
								MBIncoming[i].val = MBValor
							end
						end
					else
						MBIncoming[i].dmg = MBIncoming[i].dmg
					end
				end
				break
			end
		end
	end
end

function MythBusters.ItWasMeHealing(info)
	if info then
		-- print("Outgoing")
		-- dump(info)
		if table.maxn(MBHealOutgoing) == 0 then
			table.insert(MBHealOutgoing,{name = info.abilityName,count = 1,heal = info.heal})
			return
		end
		for i=1,table.maxn(MBHealOutgoing)+1,1 do
			if i == table.maxn(MBHealOutgoing)+1 then
				table.insert(MBHealOutgoing,{name = info.abilityName,count = 1,heal = info.heal})
				return
			end
			if MBHealOutgoing[i].name == info.abilityName then
				MBHealOutgoing[i].count = MBHealOutgoing[i].count+1
				if not MBHealOutgoing[i].heal then
					MBHealOutgoing[i].heal = info.heal
				else
					if info.heal then
						MBHealOutgoing[i].heal = MBHealOutgoing[i].heal+info.heal
					else
						MBHealOutgoing[i].heal = MBHealOutgoing[i].heal
					end
				end
				break
			end
		end
	end
end

function MythBusters.ItWasntMeHealing(info)
	if info then
		-- print("Incoming")
		-- dump(info)
		if table.maxn(MBHealIncoming) == 0 then
			if info.heal then
				table.insert(MBHealIncoming,{name = info.abilityName,count = 1,heal = info.heal})
			else
				table.insert(MBHealIncoming,{name = info.abilityName,count = 1,heal = 0})
			end
			return
		end
		for i=1,table.maxn(MBHealIncoming)+1,1 do
			if i == table.maxn(MBHealIncoming)+1 then
				if info.heal then
					table.insert(MBHealIncoming,{name = info.abilityName,count = 1,heal = info.heal})
				else
					table.insert(MBHealIncoming,{name = info.abilityName,count = 1,heal = 0})
				end
				return
			end
			if MBHealIncoming[i].name == info.abilityName then
				MBHealIncoming[i].count = MBHealIncoming[i].count+1
				if not MBHealIncoming[i].heal then
					MBHealIncoming[i].heal = info.heal
					if not info.heal then
						MBHealIncoming[i].heal = 0
					end
				else
					if info.heal then
						MBHealIncoming[i].heal = MBHealIncoming[i].heal+info.heal
					else
						MBHealIncoming[i].heal = MBHealIncoming[i].heal
					end
				end
				break
			end
		end
	end
end

function MythBusters.Death(info)
	-- killer -->info.casterName 
	-- killed -->info.targetNamed
	if info.caster == MythBustersInfo.charID then
		local MBTarget = Inspect.Unit.Detail(info.target)
		if MBTarget.player then
			if MBTarget.calling == "warrior" then
				MythBustersInfo.warrkills = MythBustersInfo.warrkills+1
			elseif MBTarget.calling == "rogue" then
				MythBustersInfo.roguekills = MythBustersInfo.roguekills+1
			elseif MBTarget.calling == "mage" then
				MythBustersInfo.magekills = MythBustersInfo.magekills+1
			elseif MBTarget.calling == "cleric" then
				MythBustersInfo.clerickills = MythBustersInfo.clerickills+1
			end
		end
	end
	
	if info.target == MythBustersInfo.charID then
		local MBCaster = Inspect.Unit.Detail(info.caster)
		if MBCaster.player then
			if MBCaster.calling == "warrior" then
				MythBustersInfo.warrdeaths = MythBustersInfo.warrdeaths+1
			elseif MBCaster.calling == "rogue" then
				MythBustersInfo.roguedeaths = MythBustersInfo.roguedeaths+1
			elseif MBCaster.calling == "mage" then
				MythBustersInfo.magedeaths = MythBustersInfo.magedeaths+1
			elseif MBCaster.calling == "cleric" then
				MythBustersInfo.clericdeaths = MythBustersInfo.clericdeaths+1
			end
		end
	end
end

function MythBusters.DisplayStats()
	MBUI:SetVisible(true)
	MBTaken:SetVisible(true)
	MBTakentext:SetVisible(true)
	MBDealt:SetVisible(true)
	MBDealttext:SetVisible(true)
	MBHealTaken:SetVisible(true)
	MBHealTakentext:SetVisible(true)
	MBHealDealt:SetVisible(true)
	MBHealDealttext:SetVisible(true)
	MBKD:SetVisible(true)
	MBKDtext:SetVisible(true)
	MBBigHits:SetVisible(true)
	MBBigHitstext:SetVisible(true)
	MBAbilitytext:SetVisible(true)
	MBCounttext:SetVisible(true)
	MBDmgtext:SetVisible(true)
	MBAvgtext:SetVisible(true)
	MBscroll:SetVisible(true)
	MBclose:SetVisible(true)
	
	local MBBigStringofNames = "Ability"
	local MBBigStringofCounts = "Counts"
	local MBBigStringofDmg = "Damage"
	local MBBigStringofAvg = "Average"
	local MBBigStringofValor = "Valor"
	
	-- MBHealTakenclick = false
	-- MBHealDealtclick = false
	-- MBBigHitsclick = false
	
	if MBTakenclick then
		if table.maxn(MBIncoming) > 50 then
			MBscroll:SetEnabled(true)
			MBscroll:SetRange(1,table.maxn(MBIncoming)-50)
			if MBscroll:GetPosition() > 1 then
			else
				MBscroll:SetPosition(1)
			end
		else
			MBscroll:SetEnabled(false)
		end
		local MBscrollpos = MBscroll:GetPosition()
		MBscrollpos = math.floor(MBscrollpos)
		--print(MBscrollpos)	
		
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBIncoming[i] then
				break
			end
			MBBigStringofNames = MBBigStringofNames .. "\n" .. MBIncoming[i].name
		end
		
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBIncoming[i] then
				break
			end
			MBBigStringofCounts = MBBigStringofCounts .. "\n" .. MBIncoming[i].count
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBIncoming[i] then
				break
			end
			if MBIncoming[i].dmg then
				MBBigStringofDmg = MBBigStringofDmg .. "\n" .. MBIncoming[i].dmg
			else
				MBBigStringofDmg = MBBigStringofDmg .. "\n" .. 0
			end
		end
		
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBIncoming[i] then
				break
			end
			--print(MBIncoming[i].name .. " / " .. MBIncoming[i].dmg)
			local tempstring = tostring(MBIncoming[i].dmg/MBIncoming[i].count)
			local templen = string.find(tempstring,"%p")
			--print(templen)
			if templen then
				tempstring = string.sub(tempstring,1,templen+2)
			else
				tempstring = tempstring
			end
			MBBigStringofAvg = MBBigStringofAvg .. "\n" .. tempstring
		end
		
		MBAbilitytext:SetText(MBBigStringofNames)
		MBCounttext:SetText(MBBigStringofCounts)
		MBDmgtext:SetText(MBBigStringofDmg)
		MBAvgtext:SetText(MBBigStringofAvg)
	elseif MBDealtclick then
		if table.maxn(MBOutgoing) > 50 then
			MBscroll:SetEnabled(true)
			MBscroll:SetRange(1,table.maxn(MBOutgoing)-50)
			if MBscroll:GetPosition() > 1 then
			else
				MBscroll:SetPosition(1)
			end
		else
			MBscroll:SetEnabled(false)
		end
		local MBscrollpos = MBscroll:GetPosition()
		MBscrollpos = math.floor(MBscrollpos)
		--print(MBscrollpos)	
		
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBOutgoing[i] then
				break
			end
			MBBigStringofNames = MBBigStringofNames .. "\n" .. MBOutgoing[i].name
		end
		
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBOutgoing[i] then
				break
			end
			MBBigStringofCounts = MBBigStringofCounts .. "\n" .. MBOutgoing[i].count
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBOutgoing[i] then
				break
			end
			MBBigStringofDmg = MBBigStringofDmg .. "\n" .. MBOutgoing[i].dmg
		end
		
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBOutgoing[i] then
				break
			end
			local tempstring = tostring(MBOutgoing[i].dmg/MBOutgoing[i].count)
			local templen = string.find(tempstring,"%p")
			--print(templen)
			if templen then
				tempstring = string.sub(tempstring,1,templen+2)
			else
				tempstring = tempstring
			end
			MBBigStringofAvg = MBBigStringofAvg .. "\n" .. tempstring
		end
		
		MBAbilitytext:SetText(MBBigStringofNames)
		MBCounttext:SetText(MBBigStringofCounts)
		MBDmgtext:SetText(MBBigStringofDmg)
		MBAvgtext:SetText(MBBigStringofAvg)
	elseif MBHealTakenclick then
		MBBigStringofDmg = "Healing"
		if table.maxn(MBHealIncoming) > 50 then
			MBscroll:SetEnabled(true)
			MBscroll:SetRange(1,table.maxn(MBHealIncoming)-50)
			if MBscroll:GetPosition() > 1 then
			else
				MBscroll:SetPosition(1)
			end
		else
			MBscroll:SetEnabled(false)
		end
		local MBscrollpos = MBscroll:GetPosition()
		MBscrollpos = math.floor(MBscrollpos)
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealIncoming[i] then
				break
			end
			MBBigStringofNames = MBBigStringofNames .. "\n" .. MBHealIncoming[i].name
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealIncoming[i] then
				break
			end
			MBBigStringofCounts = MBBigStringofCounts .. "\n" .. MBHealIncoming[i].count
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealIncoming[i] then
				break
			end
			MBBigStringofDmg = MBBigStringofDmg .. "\n" .. MBHealIncoming[i].heal
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealIncoming[i] then
				break
			end
			local tempstring = tostring(MBHealIncoming[i].heal/MBHealIncoming[i].count)
			local templen = string.find(tempstring,"%p")
			--print(templen)
			if templen then
				tempstring = string.sub(tempstring,1,templen+2)
			else
				tempstring = tempstring
			end
			MBBigStringofAvg = MBBigStringofAvg .. "\n" .. tempstring
		end
		
		MBAbilitytext:SetText(MBBigStringofNames)
		MBCounttext:SetText(MBBigStringofCounts)
		MBDmgtext:SetText(MBBigStringofDmg)
		MBAvgtext:SetText(MBBigStringofAvg)
	elseif MBHealDealtclick then
		MBBigStringofDmg = "Healing"
		if table.maxn(MBHealOutgoing) > 50 then
			MBscroll:SetEnabled(true)
			MBscroll:SetRange(1,table.maxn(MBHealOutgoing)-50)
			if MBscroll:GetPosition() > 1 then
			else
				MBscroll:SetPosition(1)
			end
		else
			MBscroll:SetEnabled(false)
		end
		local MBscrollpos = MBscroll:GetPosition()
		MBscrollpos = math.floor(MBscrollpos)
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealOutgoing[i] then
				break
			end
			MBBigStringofNames = MBBigStringofNames .. "\n" .. MBHealOutgoing[i].name
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealOutgoing[i] then
				break
			end
			MBBigStringofCounts = MBBigStringofCounts .. "\n" .. MBHealOutgoing[i].count
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealOutgoing[i] then
				break
			end
			MBBigStringofDmg = MBBigStringofDmg .. "\n" .. MBHealOutgoing[i].heal
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBHealOutgoing[i] then
				break
			end
			local tempstring = tostring(MBHealOutgoing[i].heal/MBHealOutgoing[i].count)
			local templen = string.find(tempstring,"%p")
			--print(templen)
			if templen then
				tempstring = string.sub(tempstring,1,templen+2)
			else
				tempstring = tempstring
			end
			MBBigStringofAvg = MBBigStringofAvg .. "\n" .. tempstring
		end
		
		MBAbilitytext:SetText(MBBigStringofNames)
		MBCounttext:SetText(MBBigStringofCounts)
		MBDmgtext:SetText(MBBigStringofDmg)
		MBAvgtext:SetText(MBBigStringofAvg)
	
	elseif MBKDclick then
		MBscroll:SetEnabled(false)
		local MBClassList = "\n" .. "Warriors" .. "\n" .. "Rogue" .. "\n" .. "Mage" .. "\n" .. "Cleric" .. "\n" .. "Total"
		local MBKillCount = "Kills" .. "\n" .. MythBustersInfo.warrkills .. "\n" .. MythBustersInfo.roguekills .. "\n" .. MythBustersInfo.magekills .. "\n" .. MythBustersInfo.clerickills
		local MBDeathCount = "Death" .. "\n" .. MythBustersInfo.warrdeaths .. "\n" .. MythBustersInfo.roguedeaths .. "\n" .. MythBustersInfo.magedeaths .. "\n" .. MythBustersInfo.clericdeaths
		local MBTotalKills = MythBustersInfo.warrkills + MythBustersInfo.roguekills + MythBustersInfo.magekills + MythBustersInfo.clerickills
		local MBTotalDeaths = MythBustersInfo.warrdeaths + MythBustersInfo.roguedeaths + MythBustersInfo.magedeaths + MythBustersInfo.clericdeaths
		
		MBAbilitytext:SetText(MBClassList)
		MBCounttext:SetText(MBKillCount .. "\n" .. MBTotalKills)
		MBDmgtext:SetText(MBDeathCount .. "\n" .. MBTotalDeaths)
		MBAvgtext:SetText("\n\n\n\n".. "K/D Ratio".. "\n" .. MBTotalKills/MBTotalDeaths)	
	elseif MBBigHitsclick then
		MBAvgtext:SetVisible(false)
		if table.maxn(MBIncoming) > 50 then
			MBscroll:SetEnabled(true)
			MBscroll:SetRange(1,table.maxn(MBIncoming)-50)
			if MBscroll:GetPosition() > 1 then
			else
				MBscroll:SetPosition(1)
			end
		else
			MBscroll:SetEnabled(false)
		end
		local MBscrollpos = MBscroll:GetPosition()
		MBscrollpos = math.floor(MBscrollpos)
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBIncoming[i] then
				break
			end
			MBBigStringofNames = MBBigStringofNames .. "\n" .. MBIncoming[i].name
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBIncoming[i] then
				break
			end
			MBBigStringofValor = MBBigStringofValor .. "\n" .. MBIncoming[i].val
		end
		for i=MBscrollpos,MBscrollpos+50,1 do
			if not MBIncoming[i] then
				break
			end
			MBBigStringofDmg = MBBigStringofDmg .. "\n" .. MBIncoming[i].maxhit
		end
		MBAbilitytext:SetText(MBBigStringofNames)
		MBCounttext:SetText(MBBigStringofDmg)
		MBDmgtext:SetText(MBBigStringofValor)
	end
end

function MythBusters.SlashHandler(args)
	local cmd = {}
    local numargs = 0
	local moneybarlanguage = Inspect.System.Language()
	for token in string.gmatch(args, "[^%s]+") do
			cmd[numargs] = token
			numargs = numargs + 1
	end
	if cmd[0] == "reset" then
		MythBustersInfo = initialInfo
		MBIncoming = {}
		MBOutgoing = {}
		MBHealIncoming = {}
		MBHealOutgoing = {}
		print("MythBusters Data Cleared.")
	elseif cmd[0] == "stats" then
		MythBusters.DisplayStats()
	end
end

table.insert(Event.Unit.Available,{MythBusters.Main,"MythBusters","Start Up"})
table.insert(Event.Combat.Damage,{MythBusters.WhoIs,"MythBusters","Combat Damage"})
table.insert(Event.Combat.Death,{MythBusters.Death,"MythBusters","Someone Didn't Make It"})
table.insert(Event.Combat.Heal,{MythBusters.HealWhoIs,"MythBusters","Healing"})
table.insert(Command.Slash.Register("mythbusters"),{MythBusters.SlashHandler,"MythBusters","Slash Commands"})
table.insert(Event.Addon.Load.End,{MythBusters.Build,"MythBusters","Build Frames"})